\documentclass[12pt, a4paper]{report} % o article, book, ...

% packages
\usepackage[utf8]{inputenc}
\usepackage[english]{babel}
\usepackage[hyphens]{url}
\usepackage{hyperref}
\usepackage{graphicx}
\usepackage{afterpage}
\usepackage{biblatex}
\usepackage{courier} %% Sets font for listing as Courier.
\usepackage{csquotes}
\usepackage{verbatim}
\usepackage{amssymb}
\usepackage{array}
\usepackage{changepage}
\usepackage{listings, xcolor} % for programming languages
\usepackage{wrapfig} % for image framed by text


\addbibresource{Biblio.bib}
\graphicspath{ {./images/} }

% for tabular
\newcolumntype{P}[1]{>{\centering\arraybackslash}p{#1}}
\newcolumntype{L}[1]{>{\raggedright\arraybackslash}m{#1}}
\newcolumntype{C}[1]{>{\centering\arraybackslash}m{#1}}
\newcolumntype{R}[1]{>{\raggedleft\arraybackslash}m{#1}}

\renewcommand{\arraystretch}{2}

% new command
\renewcommand{\baselinestretch}{1.4}
\newcommand\blankpage{
    \null
    \thispagestyle{empty}
    \addtocounter{page}{-1}
    \newpage
}
    
\newcommand{\cbox}[2][yellow]{%
  \colorbox{#1}{\parbox{\dimexpr\linewidth-2\fboxsep}{\strut #2\strut}}%
}
    
% colors
\definecolor{pblue}{rgb}{0.13,0.13,1}
\definecolor{pgreen}{rgb}{0,0.5,0}
\definecolor{pred}{rgb}{0.9,0,0}
\definecolor{pgrey}{rgb}{0.46,0.45,0.48}
\definecolor{gray}{rgb}{0.4,0.4,0.4}
\definecolor{darkblue}{rgb}{0.0,0.0,0.6}
\definecolor{cyan}{rgb}{0.0,0.6,0.6}

% languages
\lstdefinestyle{Apex}{language = Java,
    basicstyle=\ttfamily\footnotesize,
    showspaces=false,
    showtabs=false,
    breaklines=true,
    showstringspaces=false,
    breakatwhitespace=true,
    commentstyle=\color{pgreen},
    keywordstyle=\color{pblue},
    stringstyle=\color{pred},
    basicstyle=\ttfamily,
    numbers=left,
    stepnumber=1,
    tabsize=1,
    keywordstyle = [2]{\color{red}},
    keywordstyle = [3]{\color{blue}},
    otherkeywords = {;, +},
    morekeywords = [2]{;, Integer, String, +, trigger, Trigger, Account, Contact, Opportunity, Lead},
    morekeywords = [3]{before, isBefore, after, isAfter, on, isInsert, isDelete, List, SObject, SELECT, FROM, WHERE, FIND, IN, ALL, FIELDS, RETURNING},
}

\lstdefinestyle{myHTML}{language = html,
    basicstyle=\ttfamily\footnotesize,
    showspaces=false,
    showtabs=false,
    breaklines=true,
    showstringspaces=false,
    breakatwhitespace=true,
    commentstyle=\color{pgreen},
    keywordstyle=\color{pblue},
    stringstyle=\color{pred},
    basicstyle=\ttfamily,
    numbers=left,
    stepnumber=1,
    tabsize=1,
    keywordstyle = [2]{\color{red}},
    keywordstyle = [3]{\color{blue}},
    otherkeywords = {;, +, lightning-badge},
    morekeywords = [2]{template, false, true},
    morekeywords = [3]{lightning-badge},
}

\lstdefinestyle{JavaScript}{language = Java,
    basicstyle=\ttfamily\footnotesize,
    showspaces=false,
    showtabs=false,
    breaklines=true,
    showstringspaces=false,
    breakatwhitespace=true,
    commentstyle=\color{pgreen},
    keywordstyle=\color{pblue},
    stringstyle=\color{pred},
    basicstyle=\ttfamily,
    numbers=left,
    stepnumber=1,
    tabsize=1,
    keywordstyle = [2]{\color{red}},
    keywordstyle = [3]{\color{blue}},
    otherkeywords = {;, +, =>},
    morekeywords = [2]{export, =>, connectedCallback, ;, @api, @track, @wire},
    morekeywords = [3]{from},
}

\lstdefinestyle{CSS}{language = Java,
    basicstyle=\ttfamily\footnotesize,
    showspaces=false,
    showtabs=false,
    breaklines=true,
    showstringspaces=false,
    breakatwhitespace=true,
    commentstyle=\color{pgreen},
    keywordstyle=\color{pblue},
    stringstyle=\color{pred},
    basicstyle=\ttfamily,
    numbers=left,
    stepnumber=1,
    tabsize=1,
    keywordstyle = [2]{\color{green}},
    keywordstyle = [3]{\color{blue}},
    otherkeywords = {;, +, =>, .price, font-weight},
    morekeywords = [2]{;, margin, color, font-weight},
    morekeywords = [3]{body, .price},
}

% Per generare il file PDF aderente alle specifiche PDF/A-1b. Verificarne poi la validità.
% \usepackage[a-1b]{pdfx} % ma a me non funziona
% \usepackage{hyperref} % cancellare l'altra riga identica sopra

% oppure usare:

% https://www.pdftron.com/pdf-tools/pdfa-converter/it/
% https://pdfrecover.herokuapp.com/pdfaconvert/
% e verificare con https://www.pdfen.com/pdf-a-validator

%-------------------------------------INIZIO DOCUMENTO ----------------------------

\begin{document}

% Copertina
\begin{titlepage}
    \begin{center}
    \includegraphics[width=\textwidth]{Logo.jpg}\\
        {\large{\bf Master's Degree Course in Computer Science}}
    \end{center}
    \vspace{8mm}
    \begin{center}
        {\huge{\bf Revision of a Salesforce-based}}\\
        \vspace{3mm}
        {\huge{\bf CRM system to meet}}\\
        \vspace{3mm}
        {\huge{\bf compliance requirements in}}\\
        \vspace{3mm}
        {\huge{\bf non-European countries}}\\
    \end{center}
    \vspace{4mm}
    \begin{flushright}
        {\large{\bf Thesis by:}}\\
        \vspace{2mm}
        {\large{\bf Marco Cordoni}}\\
        \vspace{2mm}
        {\large{\bf Matr. 921030}}\\
    \end{flushright}
    \vspace{0mm}
    \begin{flushleft}
        {\large{\bf Rapporteur:}}\\
        \vspace{2mm}
        {\large{\bf Prof. Alfio Ferrara}}\\
        \vspace{7mm}
        {\large{\bf Company tutor:}}\\
        \vspace{2mm}
        {\large{\bf Dott. Giovanni Marco Barberio}}\\
        \vspace{4mm}        
    \end{flushleft}
    \vspace{3mm}
    \begin{center}
        {\large{\bf Academic year 2019/2020}}
    \end{center}
\end{titlepage}

%-----------------------------------------------------------------------------------------

\afterpage{\blankpage}

%-----------------------------------------------------------------------------------------

\tableofcontents

%-------------------------------------------------------------------------------------------------------

\chapter{Introduction}
The aim of the project, carried out by the consulting firm \textbf{Deloitte}, is to bring the customer, a well-known automotive company, to the center of the company's processes, through the redefinition and digitization of the \textbf{CRM} structure.

\begin{wrapfigure}{r}{0.35\textwidth}
    \centering
    \includegraphics[width=0.35\textwidth]{DeloitteLogo.jpg}
\end{wrapfigure}

Specifically, the goal is to allow the customer to access all information concerning him through a single tool, usable in all European and non-European countries.

It will be studied and analyzed the possibility of managing the specific requirements of \textbf{China}, regarding the storage of data on infrastructures internal or external to the Chinese territory.

First of all, in this thesis I will talk about the tools and approaches that have been used, that is: software, development methodologies and the theoretical concepts on which this project is based, explaining and analyzing the reasons for their use.

There are several non-European countries that have limits and legal constraints on the processing of user data, I will analyze both the case of China, on which this thesis is based, and Russia which in the past has already been addressed by the company in order to comply with the regulations of the country.

I will analyze in detail the preliminary phase of the development of the project, that is the moment in which the problem is studied, proposals are made on its implementation and for each one we consider advantages and disadvantages, in this chapter each part of this preparatory period is described.

Then I will indicate future developments to explain what will happen after the conclusion of the preliminary phase, which will be followed by the development and implementation of the selected technologies.

Finally, I will talk about the impact that the pandemic has had on this project, every company in Italy and in the world has been deeply affected by the pandemic that broke out at the beginning of 2020, for this reason I have decided to insert this last final part to tell how it affected on the project, how much has changed the way of working and which tools have helped to adapt to the change.

%-------------------------------------------------------------------------------------------------------

\chapter{Tools \& Approaches}
Today, competition between companies is no longer tied to the simple supply of a product or the provision of a service, but \textbf{customer loyalty} plays a fundamental role in the growth and development of any business.

This favors a return of buyers who have already had a relationship with the company and, through the collection of information on their account, allows it to adapt to reach an ever wider audience.

All this has allowed the birth of numerous means to achieve these objectives, such as \textbf {CRM}.

%--------------------------------------------------------------------------

    \section{What is a CRM}
    A \textbf{Customer Relationship Management (CRM)} is a tool to manage all relationships and interactions between the company and customers to improve the connection between these two parts.
    
    It is often called CRM System, which is the set of activities aimed at helping companies to improve their processes, profitability and sales management. \cite{whatIsCrm}
    
    A company that relies on this tool can focus more on relationships with individuals, not only customers but also colleagues and suppliers.
    
    \begin{wrapfigure}{l}{0.35\textwidth}
        \centering
        \includegraphics[width=0.35\textwidth]{CRM}
    \end{wrapfigure}
    
    It favors: search for new customers, provision of support and services during the entire relationship with the client and the collection of information through different sources, including emails, websites, social networks, advertising campaigns \textbf {B2B (Business to Business) } and \textbf {B2C (Business to Consumer)}, call centers, online and offline sales, advertising, etc.
    
    All these data are collected and stored in a systematic way, according to the business logic and commercial objectives.

%----------------------------------------------------

        \subsection{Who is a CRM for}
        CRM offers everyone, sales, customer service, development, recruiting, marketing, or any other company figure, a better way to manage interactions with other individuals.
        
        It allows to store information about customers and potential customers, identify sales opportunities, log service issues and manage marketing campaigns, all in one place, exposing this information to anyone who may need it.
         
        Thanks to the easy access to data and use of methods to limit the visibility to only a particular category of users, it is easier to collaborate and increase productivity.
        
        Everyone in the company can see what customers reported, what products they bought, when they last bought, how much they paid, and more.
        
        CRM can help businesses of all sizes to drive their growth and can be especially beneficial for a small company, where teams often need to find ways to perform best with few resources.
        
%----------------------------------------------------

        \subsection{CRM in the cloud}
        CRM use all the advantages of \textbf {cloud computing}, without having to install software on hundreds or thousands of desktop computers and mobile devices, companies all over the world can enjoy all the benefits of transferring data, software and services on an online \textbf {secure} environment.
        
        \bigskip 
        \bigskip
        
        \noindent
        \centerline{\includegraphics[scale=0.52]{CRM-Cloud.jpg}}
            
        \newpage

        A cloud-based CRM system offers the following benefits:

        \begin{itemize}
            \item \textbf {Faster implementation}: The implementation is extremely fast and easy, as there is no laborious installation process required and there is no hardware to configure or maintain.
            
            This keeps costs low and we don't have to worry about software version checking and scheduling updates.
            
            \item \textbf {Automatic Software Updates}: Cloud systems are updated in real time by the vendor. This way there is no system downtime or additional costs due to hardware components, software or server maintenance and upgrades. So there is one less element to manage.
            
            \item \textbf {Cost Reduction and Scalability}: Cloud-based CRM systems are typically priced based on the number of users accessing the system and the type of features required.
            
            With reduced upfront costs and consistent, predictable pricing over time, the cloud can be very cost-effective. It is also extremely flexible and offers scalability by simply adding more people to the system as the business grows.
            
            \item \textbf {Ability to work from anywhere and on any device}: Cloud-based CRM systems ensure that all users always have the same information.
            
            Field sales teams can check the data, update it immediately after a meeting, and work from anywhere. The same information is available to anyone who needs it, from sales reps to customer service.
            
            \item \textbf {Greater collaboration}: Physically distant teams can collaborate without the need to make significant investments in infrastructure. Members of different groups, locations and even territories can easily connect with each other and intelligently share data to support each other.            
        \end{itemize}
        
%----------------------------------------------------
        
        \subsection{Summary of the benefits}
        \begin{itemize}
            \item \textbf {Optimize the relationship with customers}: improves the relationship with customers by favoring their return to the company with which they found themselves at ease.
            
            \item \textbf {Making marketing efficient}: exploiting the data collected from customers it is possible to optimize marketing techniques.
            
            \item \textbf {Increase company turnover}: the combination of more effective marketing techniques and customer loyalty allows an increase in company turnover.
            
            \item \textbf {Improve sales performance}: CRM systems allow you to organize an extremely precise inbound marketing process, selling to customers exactly the products they want to buy.
            
            \item \textbf {Improve corporate communication}: sharing customer data between the various departments allows the company to work as a single team.
            
            \item \textbf {Cloud computing}: CRM exploits all the advantages of the cloud: speed, simplicity and the economic savings that it entails.            
        \end{itemize}
        
        \newpage

%--------------------------------------------------------------------------
        
    \section{Introduction to Salesforce}
    \textbf {Salesforce.com} is an American cloud software company headquartered in San Francisco, California.
    
    It provides a \textbf {Customer Relationship Management} and also sells a complementary suite of business tools focused on customer service, marketing automation, analytics and application development.    
    
    \begin{wrapfigure}{r}{0.35\textwidth}
        \centering
        \includegraphics[width=0.35\textwidth]{Salesforce_logo.png}
    \end{wrapfigure}    

    In 2020, Fortune magazine ranked Salesforce sixth on the "Top 100 Companies to Work For List". \cite {whatIsSalesforceWiki}    
    
%----------------------------------------------------
    
        \subsection{History}
        The company was founded on February 3, 1999 by former Oracle members as \textbf {Software as a Service (SaaS)} and was publicly launched between September and November 1999.
        
        In June 2004, the company made its initial public offering on the New York Stock Exchange under the stock symbol CRM and raised 110 million dollars.
        
        In October 2014, Salesforce announced the development of its \textbf {Customer Success Platform} to connect its services, including: sales, support, marketing, analytics, community and mobile apps.
        
        In October 2017, it launched a Facebook analytics tool for business-to-business marketing.
        
        Finally, in September 2018 he partnered with Apple to improve apps for business.        
        
%----------------------------------------------------
        
        \subsection{Services}
        All the services offered by Salesforce work in \textbf {multitenancy}, being the platform entirely in the cloud, they share resources with all other users. They all have the same computational resources, available space and core functionality.
        
        \begin{wrapfigure}{l}{0.57\textwidth}
            \centering
            \includegraphics[width=0.55\textwidth]{lightning-overview-jumbo-device.png}
        \end{wrapfigure}             

        While the space is shared with other companies, Salesforce keeps all data safe. Receiving the latest and greatest features without any interruption, updates are provided three times a year.
        
        It is thanks to multitenancy that no user ever has to install any software or worry about their hardware.\cite{salesforceMultitenancy}
        
        \noindent
        These are the services provided by the platform:
        
        \begin{itemize}
            \item \textbf {Salesforce}: is the main company offering within the platform.
            
            It allows companies to efficiently manage the relationship with customers through:

            \begin{itemize}
                \item \textbf{Lead}: potential customers, or users interested in purchasing who have not yet incurred any expenses.
                
                \item \textbf{Opportunity}: purchases in progress by customers, these are followed at every stage in order to be satisfied.
                
                \item \textbf{Case}: represent support requests from customers who have made purchases, they can be: questions, feedback or problems.
            \end{itemize}
            
            In Salesforce, these 3 elements are called "\textbf {objects}", there are also many others objects built-in and they can be created by developers.
            Objects represent the database tables that Salesforce CRM offers.

            Salesforce integrates with other websites and social networks, provides analytics tools and other services including email, Google, and access to customer rights and contracts.
            
            \item \textbf {Lightning Platform}: Also known as \textbf {Force.com}, this is a \textbf {Platform as a Service (PaaS)} that allows developers to create additional applications that integrate into the main application Salesforce.com.
    
            These applications are built using declarative tools, such as the \textbf {Lightning} interface, or using the Java-like, Force.com-exclusive \textbf {Apex} (Application Express) programming language.
            
            \item \textbf {Work.com}: is a \textbf {Social Performance Management} platform that helps managers and employees improve work performance through continuous coaching and real-time feedback.            
            
            \item \textbf {AppExchange}: is a third-party online application marketplace running on the Force.com platform. Applications are available for free or via annual or monthly subscription.            
            
            \item \textbf {Trailhead}: is an online training platform that offers a guided learning path through the key features of Salesforce, after each lesson there is an assessment of the knowledge learned through single or multiple choice quizzes or exercises to be solved within a development environment provided from the platform itself.            
            
            \item \textbf {Blockchain platform}: Announced on May 29, 2019, Salesforce launched a blockchain platform to facilitate the creation of blockchain networks and apps integrated with CRM.            
        \end{itemize}
        
        \newpage
        
%--------------------------------------------------------------------------
    
        \subsection{Modules}
        \textbf {Salesforce Customer 360} is a Salesforce data management tool that is divided into a series of different products, called modules, each of which offers specific features, they are: \cite {salesforceModules}        
    
        \begin{itemize}
            \item \textbf {Sales Cloud}: is the module for the sales team, allows contact management, promotes collaboration and offers marketing tools for finding new customers, managing \textbf {leads} and \textbf {opportunity}, potential and confirmed customers, until the conclusion of the negotiations and the obtaining of sales data.
            
            Includes dashboard and reporting capabilities so you can analyze team performance.
            
            \item \textbf {Service Cloud}: Used by customer service for assistance, to create self-service portals and offer support to employees.

            It allows access to the details, context, history of each case, allows interaction with the customer, the automation of assistance and approval processes and automatically matches the houses to the best agent for each customer.            
            
            \item \textbf {Marketing Cloud}: helps companies offer personalized marketing to customers by understanding their interests and analyzing the effects this produces.
                        
            Salesforce Marketing Cloud has nearly a dozen built-in tools that businesses can use to plan, launch marketing campaigns, archive data, custom notifications for mobile devices, social media integration, and specific advertising based on user interest.            
            
            \item \textbf {Commerce Cloud}: includes business-to-consumer and business-to-business products.
            This module is broken down into different e-commerce solutions, each using artificial intelligence to adapt the shopping experience of customers based on their behavior.
                
            \item \textbf {Analytics Cloud}: it automate data usage by providing answers to questions like "Why did X happen?" or "What will happen in the future?", artificial intelligence is an important part of this module.
    
            It provides advice on action, dashboards, and allows all team members to view the same records for discussion.            
                
            \item \textbf {Community Cloud}: can be used to create self-service portals for customers, allows them to access and update their accounts, allows partners to collaborate with the company and create and manage communities.            
        \end{itemize}
    
%----------------------------------------------------

        \subsection{Heroku}
        \textbf {Heroku} is a PaaS hosted on Amazon Web Services with a large ecosystem of pre-build components very useful for speeding up the delivery, scalability and maintenance process of applications.
        
        \begin{wrapfigure}{r}{0.25\textwidth}
            \centering
            \includegraphics[width=0.25\textwidth]{heroku-logo.png}
        \end{wrapfigure}        
        
        Instead of directly using an \textbf {Infrastructure as a Service} like AWS that offers only the hardware on which developers will install the software, Heroku already comes with an operating system ready to receive applications, speeding up the production process.

        For this project, Heroku is used to define an API Gateway, which is a single access point for devices that want to interface with Salesforce.
        
        The reason why this is done is that Salesforce imposes a monthly limit of API calls that can be made, this is related to multitenancy and the need not to monopolize shared resources.
        
        This method avoids exceeding the call limit, now users will access the data contained in Heroku which will subsequently be sent to the main database.
        
        \textbf {Heroku Connect} is the add-on responsible for real-time synchronization of Salesforce data with a \textbf {Postgres} database integrated into Heroku.
        
        It uses a simple declarative interface that determines which Salesforce objects need to be synchronized and with which Postgres tables, mapping the fields of the objects into the columns of the table. 
        
        All data brought into Heroku is encrypted to ensure its security.
        
        Heroku Connect monitors the organization of the tables, ensuring that objects are created as needed.
        
        \begin{wrapfigure}{l}{0.58\textwidth}
            \centering
            \includegraphics[width=0.58\textwidth]{heroku.png}
        \end{wrapfigure}
        
        Instead, if an application had been created that directly invoked the Salesforce APIs, this could have caused the number of monthly calls to be reached, blocking database updates until the new month or otherwise causing an overall slowdown of the system due to the increased number of requests to manage.
        
%--------------------------------------------------------------------------    
    
    \newpage
    \section{Lightning Web Components}
    \textbf {Lightning Component} is a \textbf {framework} for the user interface, it allows the development of applications for mobile and desktop devices.
    
    With this tool we can create "components", they are elements that can be inserted in the interface, they incorporate specific functions and there are two programming models to make them.
    
    The models are \textbf {Aura Components} and \textbf {Lightning Web Components}, the first is older and over time will be totally discontinued to be replaced by the Lightning Web Components, the second was introduced in 2019 and offer many advantages.
    
    \begin{wrapfigure}{r}{0.65\textwidth}
        \centering
        \includegraphics[width=0.6\textwidth]{lightning-web-components.png}
    \end{wrapfigure}
        
    Lightning Web Components, often called \textbf {LWC}, are elements created using primarily HTML and JavaScript.
        
    LWC and Aura Components can coexist and interact on the same page, in this way older projects that do not use the new technology can safely continue to work without modifications. \cite {whatIsLWC}
    
    \newpage
    The following table summarizes the differences and advantages that LWCs offer compared to the old standard: \cite {lwcAuraDiff}
        
\begin{center}
    \begin{tabular}{C{7cm}|C{7cm}}
        \hline
            \textbf{Lightning Aura Components} & \textbf{Lightning Web Components} \\
        \hline
            It uses a standardized \textbf {JavaScript} framework.
                & 
            It uses standard tools like \textbf {CSS}, \textbf {HTML} and modern \textbf {JavaScript} (ECMAScript 7). \\
            
        \hline
            Users must have good knowledge of the Salesforce platform. 
                & 
            like modern web standards, developers don't need to be familiar with the Salesforce architecture. \\
        \hline
            They are not very immediate to learn to use, therefore they require a long learning time. 
                & 
            They have a simpler structure to understand. \\
        \hline
            Code reuse is supported. 
                & 
            Code reuse is supported. \\
        \hline
            It does not support the framework for \textbf {unit test}.
                & 
            It supports the \textbf {unit test} framework to ensure code quality. \\
        \hline
            The code does not run natively in browsers. 
                & 
            Natively supported in the browser, this allows for greater performance in running applications. \\
        \hline
    \end{tabular}
\end{center}
    
%--------------------------------------------------------------------------
   
    \section{Languages used \& Development tools}
    Within each Salesforce project, different languages collaborate, each with a specific purpose and distinct between:
    
    \begin{itemize}
        \item for the \textbf {client} or for the \textbf {server}
        \item for \textbf {programming} or just \textbf {markup}
        \item \textbf {owned by Salesforce} and \textbf {non-owned}        
    \end{itemize}

%----------------------------------------------------

        \subsection{Apex}
        \textbf {Apex} is a Salesforce proprietary, object-oriented, strongly typed programming language that allows developers to execute flow control statements on servers. \cite {whatIsApex}
                
        Its syntax is very similar to \textbf {Java}, allowing developers to quickly learn it to add business logic to applications.        
         
\begin{lstlisting}[style = Apex, caption=Apex example]
public class MySampleApexClass { // Class definition
   public static Integer myValue = 0;  // variable
   public static String myString = ''; // variable
   
   public static Integer getCalculatedValue () {
   // Method definition and body
   // do some calculation
      myValue = myValue + 10;
      return myValue;
   }
}
\end{lstlisting}
        
        Can be executed by client requests and \textbf {triggers} on objects in the Salesforce database after insertions, updates and deletions.        
        
\begin{lstlisting}[style = Apex, caption=Trigger example  \cite{apexTrigger}]
trigger ContextExampleTrigger on Account (before insert, after insert, after delete) {
    if (Trigger.isInsert) {
        if (Trigger.isBefore) {
            // Process before insert
        } else if (Trigger.isAfter) {
            // Process after insert
        }        
    }
    else if (Trigger.isDelete) {
        // Process after delete
    }
}
\end{lstlisting}        
        
        It works in a \textbf {multi-tenant environment}, so it is designed to prevent the monopolization of shared resources. 
        
        Any code that violates the limits returns easy-to-understand error messages.
        
        It provides support for creating and running unit tests, test results indicate how much of the code was covered and which parts could be more efficient.
        
        Salesforce ensures that all Apex code created works as intended by running all unit tests before each deploy, so whenever there is a new release of new features or bug fixes.
        
        \newpage
        Here are various types of built-in support that it provides:
        
        \begin{itemize}
            \item \textbf {DML calls} (Data Manipulation Language), like INSERT, UPDATE and DELETE, the handling of DmlExceptions is already built in.
            
            \item \textbf {Inline Salesforce Object Query Language} (SOQL) and \textbf {Salesforce Object Search Language} (SOSL), are queries that return lists of sObject records, database objects according to defined criteria.
        \end{itemize}
        
\begin{lstlisting}[style = Apex, caption=SOQL example  \cite{soqlAndSosl}]
List<Account> a = [SELECT Id, Name 
                   FROM Account 
                   WHERE Name = 'Acme'];
\end{lstlisting}

\bigskip
\bigskip

\begin{lstlisting}[style = Apex, caption=SOSL example]
List<List<SObject>> searchList = [
        FIND 'map*' IN ALL FIELDS 
        RETURNING Account (Id, Name), 
            Contact, Opportunity, Lead];
\end{lstlisting}

        \begin{itemize}
            \item Loops that allow processing of multiple records at a time, called \textbf {Bulk}.
        
            \item \textbf {Blocking syntax} to prevent conflicts when updating records.
        
            \item Custom \textbf {API} calls, created by Apex methods stored in appropriate helper classes.
        
            \item \textbf {Warnings and errors} that appear when a user attempts to modify or delete an object or field.
        \end{itemize}
        
%----------------------------------------------------

        \subsection{HTML}
        Each LWC needs a \textbf {HTML} (HyperText Markup Language) file in order to appear within a web page on the client, this markup file must include the \textcolor {red} {template} tag. This tag will contain the HTML code that defines the structure of the component.        

\begin{lstlisting}[style = myHTML, caption = Html example \cite{lwcHtml}]
<template>
    <div>
        <div>Name: {name}</div>
        <div>Description: {description}</div>
        <div>Category: {category}</div>
        <div>Material: {material}</div>
        <div>Price: {price}</div>
        <div><img src={pictureUrl}/></div>
    </div>
</template>
\end{lstlisting}          
        
        \noindent
        \centerline{\includegraphics[scale=0.41]{lwc-bike2.jpg}}        

%----------------------------------------------------

        \subsection{JavaScript}
        The client-side component logic is contained in the \textbf {JavaScript} file, which defines functions for handling inputs, data, events, state changes, and more.
        
\begin{lstlisting}[style = JavaScript, caption = JavaScript example \cite{lwcHtml}]
import { LightningElement } from 'lwc';
export default class App extends LightningElement {
   name = 'Electra X4';
   description = 'A sweet bike built for comfort.';
   category = 'Mountain';
   material = 'Steel';
   price = '$2,700';
   pictureUrl = 'https://veryLongUrl/electrax4.jpg';
}
\end{lstlisting}      
        
        LWCs provide built-in methods called "\textbf {hooks}" to handle critical events in the life cycle of a component. like:
        
        \begin{itemize}
            \item Creation
            \item Addition to DOM
            \item Rendering in the browser
            \item Encounter of errors
            \item Removal from DOM
        \end{itemize} 
        
        The \textbf {DOM} (Document Object Model) is the structure of the document itself in which the LWC is inserted.
        
%----------------------------------------------------

        \subsubsection{Shadow DOM}
        In Salesforce there is also the \textbf {Shadow DOM} which encapsulates the DOM of each component, isolating them from each other and providing protection from external manipulation.
        
        The only way that the components have to communicate are the \textbf {events}, that is explicit declarations of wanting to send information to another component, these data may have been generated within the same component or received by others components via an event.
        
        A component, in order to receive the information, must explicitly subscribe to the same event that sent this data.
        
        For simplicity, events are distinguished from each other by a developer-defined name.
        
%----------------------------------------------------

        \subsubsection{Lightning Locker}        
        To ensure greater security there is also the \textbf {Lightning Locker}, it provides security to components through isolation from code external to Salesforce, allowing only standard and secure APIs and event mechanisms, prohibiting access by undocumented or private APIs.
        
        Lightning Locker is enabled by default for all LWCs, both standard and custom.
        
        \newpage

%----------------------------------------------------        

        \subsubsection{Hooks}
        Hooks that can be used and when they are called:        
        
        \begin{itemize}
            \item \textbf{connectedCallback()}: when a component is inserted into the DOM.

            \item \textbf{constructor()}: when a component is created, prior to connectedCallback.
            
            \item \textbf{disconnectedCallback()}: opposite of connectedCallback(), invoked when the component is removed from the DOM.
            
            \item \textbf{errorCallback(error, stack)}: called when a child component throws an error, the name of the thrown exception is present in the \textbf {error} argument, instead the \textbf {stack} argument is a string.
            
            \item \textbf{render()}: an explicit call to this method is used to update the UI, for example to render a template.
            
            \item \textbf{renderedCallback()}: called automatically after each time it is rendered, that is when the value of a property is modified and this element was directly present in the template or indirectly in the getter of a property used in the template.
        \end{itemize}
        
\begin{lstlisting}[style = JavaScript, caption = JavaScript example]
import { LightningElement } from 'lwc';
export default class App extends LightningElement {
    ready = false;
    connectedCallback() {
        setTimeout(() => {
            this.ready = true;
        }, 3000);
    }
}
\end{lstlisting}
        
%----------------------------------------------------

        \subsubsection{Decorators}
        
        Decorators are used to modify the behavior of a property or a function, to use them it is necessary to import the \textcolor {red} {lwc} module.
        
\begin{lstlisting}[style = JavaScript, caption = JavaScript example]
import { LightningElement, api } from 'lwc';
export default class MyComponent extends LightningElement{
    @api message;
}
\end{lstlisting}

        The decorators are:
        \begin{itemize}
            \item \textbf {@api}: marks a field as public, public properties define the component API.
            
            A parent component that uses a child component in its HTML markup can access the child's public properties. All public properties are responsive, which means that the framework observes the property for changes.
            
            When the property value changes, the framework reacts and renders the component.            
            
            \item \textbf {@track}: tells the framework to observe changes to the properties of an object or elements of an array. 
            
            If a change occurs, the framework renders the component but the property is not public.
            
            \item \textbf {@wire}: allows to call a server-side Apex function and get its return value.
        \end{itemize}
        
        \newpage
        
        In the following example the \textbf {getRecord} function is imported and, passing it the \textbf {recordId} received externally with the \textcolor {red} {@api} decorator, the \textbf {record} field is populated exactly by the element that owns that id.
            
\begin{lstlisting}[style = JavaScript, caption = @wire example]
import { LightningElement, api, wire } from 'lwc';
import { getRecord } from 'lightning/uiRecordApi';

export default class MyClass extends LightningElement{ 
    @api recordId;

    @wire(getRecord, {recordId: '$recordId'})
    record;
}
\end{lstlisting}

%----------------------------------------------------

        \subsection{CSS}
        Each HTML file can be associated with a \textbf {CSS} (Cascading Style Sheets) to define how the elements in the HTML should appear, the same code can be reused in different files. It allows to customize the display on different devices. \cite {lwcCss}
        
\begin{lstlisting}[style = CSS, caption = CSS example]
body {
  margin: 0;
}
.price {
  color: green;
  font-weight: bold;
}
\end{lstlisting}        

%----------------------------------------------------

        \subsection{Visual Studio Code}
        \textbf {Visual Studio Code} is a lightweight but powerful code editor, executable on the desktop and available for Windows, macOS and Linux.        
        
        \begin{wrapfigure}{r}{0.35\textwidth}
            \centering
            \includegraphics[width=0.3\textwidth]{Visual-studio-code.png}
        \end{wrapfigure}        
        
        It comes with built-in support for many languages including HTML, JavaScript, CSS and, by installing a special plug-in on the Visual Studio Marketplace, even Apex.
                
        Its strength is precisely the high amount of extensions created to facilitate the work of programmers, among which there are tools for Salesforce, to be able to work with development Org, Aura Component, LWC and Visualforce.        
        
        One of the most relevant plug-ins is \textbf {Salesforce DX}, this tool improves team development and collaboration, facilitates automated testing, continuous integration, and makes the release cycle more efficient and agile. \cite {sfdx}        
        
%----------------------------------------------------

        \subsection{Git}
        
        \begin{wrapfigure}{l}{0.45\textwidth}
            \centering
            \includegraphics[width=0.4\textwidth]{git-logo.png}
        \end{wrapfigure}  
        
        \textbf {Git} is a distributed version control tool, each developer has a copy of the entire repository at all times, including all branches and commits. \\
        
        \noindent
        The core elements of Git are as follows: \cite{gitDev}
        \begin{itemize}
            \item \textbf{Repository}: collection of source files used to compile the project.

            \item \textbf{Commit}: a snapshot of the project in a specific time. During development they are defined to indicate where elements or features have been added or removed.

            \item \textbf{Branch}: a series of commits representing changes in the project over time. Each repository has a default branch that contains the version ready to go to production. 
            
            Over time, additional branches will be created to work on new features, fix bugs, or make other changes to the project.
            
            These branches keep the experimental code separate from the tested production code.

            \item \textbf{Merge}: the combined history of two or more branches, for example to merge the new features with the branch destined for production functionality.

            \item \textbf{Tag}: a pointer to a specific commit, which provides a persistent reference to an event. 
            
            Typically, tags are used to represent where the various releases of the application have occurred.
        \end{itemize}
        
        With all these elements, teams can work efficiently and collaborate to solve problems or develop numerous features in parallel that will then be integrated in the future.

%--------------------------------------------------------------------------
    
    \section{Pattern MVC}
    Salesforce uses the \textbf {MVC} (Model View Controller) architectural pattern to separate the representation of information (model) from how users interact with it (view) by defining components that allow communication between the 2 parts (controller ). \cite {mvcPattern1} \cite {mvcPattern2}
    
    The \textbf {controller} sends commands to the associated view to modify the presentation it has on the data and communicates with the model to update its state.
    
    The controllers are present on the server side through \textbf {Apex} functions and on the client side in the \textbf {JavaScript} files, they receive the data as input and manipulate it to satisfy the user's requests.
    
    The \textbf {model} notifies views and associated controllers when a change in its state occurs, allowing to produce updated output and to modify the available command set.
    
    \begin{wrapfigure}{r}{0.55\textwidth}
        \centering
        \includegraphics[width=0.55\textwidth]{mvc_pattern.png}
    \end{wrapfigure}        
    
    It includes the \textbf {object standard} and those \textbf {custom} present in the database, in Salesforce the \textbf {object} are the tables that contain information about the company and its users.
    
    The \textbf {views} requires to the model the information needed to generate a data representation.
    There are built-in views via the \textbf {Lightning Experience} platform, which can be declared declaratively without using the code, or views created with the LWC using only programming languages.
    
    \newpage
    
%--------------------------------------------------------------------------    

    \section{Agile development methodology}
    \textbf {Agile} represents an \textbf {iterative} approach to work management and software development, it helps teams deliver results to the client faster and with less difficulty.
        
    Instead of releasing the entire project at once, an Agile team delivers results in small increments.
    
    In the development team of this project, the working time is divided into \textbf {sprint} of 5 weeks, 3 of development and 2 of test, there is a constant \textbf {communication with the client}, the working group is \textbf {self-organizes} to divide tasks in the most efficient way and there is \textbf {open communication} between all members.
    
    Requirements, work plans and results are evaluated continuously, this is called \textbf {Continuous Delivery} and makes it easier to identify errors so that they can be corrected before they reach the end user.
    
    \begin{wrapfigure}{l}{0.45\textwidth}
        \centering
        \includegraphics[width=0.45\textwidth]{agile.png}
    \end{wrapfigure}   
    
    Agile was born from the need to abandon the traditional "cascade" approach, in which the project proceeded without ever reviewing the previous phases, moving instead to collaborative groups and always in contact with the customer.
    
    There must be open communication, collaboration, adaptation and trust between team members, with the ability to decide how the work will be done, self-organizing around granular tasks and assignments.
    
    Agile is a group of methodologies that demonstrate a commitment to tight feedback loops and continuous improvement. \cite {whatIsAgile}

%----------------------------------------------------    

        \subsection{Continuous Integration}
        \textbf {Org} is the abbreviation for "organization", it is the virtual space provided to a single Salesforce user, each one includes data and applications and is separate from all the others.
        
        For the realization of this project, at each Org has been associated with a branch of Git in order to perform the versioning of metadata that they contains.
        
        Many Orgs are created for development, different for the purpose for which they are intended:        
        \begin{itemize}
            \item Each programmer has his own \textbf {Development Org}.
            
            \item All the new features generated on the orgs of the developers converge in an Org called \textbf {Dev}, where all the changes made will be validated.
            
            \item Once the changes have been validated, they pass within an Org called \textbf {UAT} which is also visible to the customer, to allow the latter to test the implemented functionalities.
            
            \item After the test phase, the changes enter in the \textbf {Production Org}.
        \end{itemize}
        
        Through these occurs the \textbf {Continuous Integration}, the developers work only on their own Org and no one else must be directly modified.
        
        \newpage
        
%----------------------------------------------------    

        \subsection {Pull request}
        Whenever a developer wants to integrate new changes into Dev, they must execute a \textbf {pull request}.
        
        In the case of this project, each pull request triggers all unit tests to verify that the changes did not introduce errors and the entire system continues to work properly.
        
        \begin{wrapfigure}{r}{0.35\textwidth}
            \centering
            \includegraphics[width=0.4\textwidth]{bitbucket-logo.png}
        \end{wrapfigure}         
        
        Among the various existing tools that implement pull requests, the team in charge of developing this project opted to use \textbf {Bitbucket}
        
        Bitbucket provides numerous features through a clean and fast learning interface. \cite {whatIsPullReq}
        
        It's a Git-based cloud tool for collaborating and hosting code, built for teams.
                
%------------------------------------
    
        \subsubsection{Creating a pull request}
        These are the actions that the developer must take:
        
        \begin{enumerate}
            \item Create a new feature in a dedicated branch in your local repository.

            \item Send the branch to a public Bitbucket repository.
        
            \item Generate a pull request via Bitbucket.
        
            \item The rest of the team examines the code, discusses it and modifies it.
        
            \item The project maintainer joins the functionality to the main repository and closes the pull request.
        \end{enumerate}

%-------------------------------------------------------------------------------------------------------

\chapter{Outside Europe}
Some countries in the world have laws that place legal constraints and limits regarding the processing and storage of data collected from users on their territory.

Before examining the case of China, I want to focus on what happened in Russia, whose project has already been completed.

%--------------------------------------------------------------------------    

    \section{The case of Russia}
    The Russian law on the protection of personal data requires that these, before being saved on servers outside the territory of Russia, must always be stored on internal country databases.
    
    Therefore, it is not forbidden to save data outside Russia but a copy of them must always be present inside \textbf {local servers}.    
    
    The data subject to this restriction are all those that can be traced back to the relative Russian citizen, such as the combination of name, surname and address, the first 2 are not sufficient to uniquely identify an individual.Every citizen must sign the consent for the processing of his data.
    
    \newpage
    
    Furthermore, the data relating to Russian citizens that must be saved on servers located on American territory must always be encrypted and can only be viewed after a notification on the Russian server.
    
    This case is much simpler than the situation in China, as the objective is more defined and the structure of the project remains unchanged, it is only necessary to add the appropriate methods to allow data to be saved.

%--------------------------------------------------------------------------    

    \section{The data protection law in China}
    For the realization of this project, the case of China was studied regarding the storage of data on infrastructures inside or outside the Chinese territory. \cite {chinaLawBriefOverview}
    
    In China, cybersecurity and personal data protection have witnessed rapid legislative developments in the years 2018 and 2019.
    
    Some provisions of the IT Security Law of the People's Republic of China (hereinafter referred to as the "Cybersecurity Law" or CSL) were then clarified by the new legislation.

%--------------------------------------------------------------------------
    
        \subsection{Legal sources on the protection of personal data}
        A basic legal system for the protection of personal data has already been established which establishes the compliance requirements to be followed for those operating in the market.
        
        This system consists of laws, administrative regulations, regulations / provisions of national regulatory bodies, national legal standards, national standards, industry standards, etc.        
        \newpage
        Here, there are some key points relating to data protection:
        
        \begin{itemize}
            \item \textbf {Article 25 of the National Security Law of the People's Republic of China}: specifies that the nation must establish systems for safeguarding network and information security.
            
            The nation will safeguard the security of information systems and data for IT infrastructures, also called Critical Information Infrastructure ("CII"), and key industries.
            
            The nation must prevent, stop and penalize cybercrime such as network attacks, intrusion, theft and dissemination of illegal and harmful information, etc.       
            
            \item \textbf {Article 111 of the general provisions of civil law of the People's Republic of China}: establishes the fundamental principle that the personal data of the natural person are protected by law, any organization and individual must collect personal data after obtaining the consent of the interested and conduct the collection according to the law, ensuring the security of the personal data collected.
                        
            The illegal collection, use, processing and transmission of the personal data of others, illegal sales / purchase transactions of personal data and the illegal provision / disclosure of personal data are prohibited.            

            \item \textbf {The IT security law}: establishes the legal principles and requirements on the protection of personal data collected and / or processed via networks.
            
            The compliance requirements established by this law apply universally to all network operators. Some provisions are similar to those contained in the European Union General Data Protection Regulation (GDPR).
        \end{itemize}

%--------------------------------------------------------------------------

        \subsection{Terminology regarding personal data}
        
        \begin{itemize}
            \item \textbf {Personal data}: There are various definitions for this terminology.
                        
            According to the IT security law, "personal data" refers to various information recorded in electronic format, or in any other form, and used alone or in combination with other information to recognize the identity of a person.
            
            Such as: name, date of birth, identification code, biometric data, address and telephone number.
            
            This definition is expanded to include various information that, solely or in combination with other information, reflects the status of the business of specific individuals, including telecommunications contact information, account passwords, property status, locations of permanence and tracking records.
            
            \item \textbf {Sensitive personal data}: data which, if disclosed, provided illegally or used improperly, can probably cause damage to the person, property, reputation, physical or mental health or trigger discriminatory treatment for the interested,            
            
            \item \textbf {Data subject}: person identified by personal data.
        \end{itemize}

%--------------------------------------------------------------------------

        \subsection{Principles on data processing}
        According to the IT security law, some important principles must be guaranteed for the processing of personal data:
    
        \begin{itemize}
            \item \textbf {Legality}: the collection, use and processing of personal data must not violate laws, administrative regulations or the agreement concluded with the interested parts.
        
            \item \textbf {Transparency}: network operators must publish rules for the collection and use of personal data and inform data subjects about the purposes for which the data is collected or used.
            
            \item \textbf {Consent}: the consent of the interested part must always be obtained before collecting their personal data.
            
            \item \textbf {Purpose limitation}: Data subjects must be informed about the purpose of the collection and use of personal data.
            
            The use of personal data must not exceed the scope that is directly or reasonably related to the purpose communicated by the controller prior to the data collection, where it is necessary to exceed the scope, further explicit consent must be obtained from the data subjects personal.
            
            \item \textbf {Data minimization}: the data collected respect the "necessary" principle and no irrelevant ones are collected.
            
            \item \textbf {Integrity and confidentiality}: those responsible for data collection must ensure its security, protection from loss, destruction or damage.
            
            Such information will not be provided to other parts without the consent of the data subjects or legal requirements.
            
            Unless, data has been processed in a way that makes it impossible to identify the subjects.
        
            \item \textbf {Limitation on storage}: derives from the principle of "necessary", defines the period of time for the retention of personal data.
            
            At the end of this period, data must be adequately removed by deletion or anonymization.
        \end{itemize}
    
        \newpage
        
%--------------------------------------------------------------------------

        \subsection{Legal requirements imposed by China}
        Cyber security laws require that all data collected in China cannot be stored on servers outside its territory, other than anonymously.
        
        The \textbf {Cybersecurity Law (CSL)} involves only a subset of customer data, such data is called \textbf {Personal Identification Information (PII)}.
        
        PII is all information that, individually or through a combination of them, allows the identification of a person, including information such as: name, date of birth, identity card number, personal account information, address, number of telephone, etc.
        
        The restrictions are imposed on all Chinese customers, but what is meant by "\textbf {Chinese customer}"?
        
        This refers to any customer whose data was collected on the territory of China by a Chinese retailer, this is not related to the nationality or address of the person, it means that if a German user goes to a Chinese retailer they will have to be treated according to the CSL.
        
        Chinese customer data collected outside of China (for example in Italy) is excluded from the CSL and restrictions should not apply.  
        
        Furthermore, Chinese laws impose a constraint on the mobile app, presenting a problem for Android devices because there is no Play Store in China where it can be distributed and downloaded as in the rest of the world.

%-------------------------------------------------------------------------------------------------------

\chapter{Project development phases}
This chapter analyzes the problem and presents the solutions to deal with it, if errors are made in this phase they will fall on future phases causing an expansion of the estimated times and a greater economic expenditure.

Therefore, each stage of development has been conceived with the aim of minimizing this possibility through careful collection and analysis of information.

%--------------------------------------------------------------------------

    \section{Discovery}
    In the first phase we will consider the \textbf {current situation} of the company and what are in detail the \textbf {requests imposed} by China.
    
%---------------------------------------------------------------

        \subsection{As-Is}
        The current platform used by the client company has no restrictions on the location of the stored data, with the exception of Russia.
        
        If a customer registers at a branch, for example in Italy, his data does not necessarily have to be stored on servers in the same territory and it is possible to access the data saved on databases located in a different country without any restrictions.
        
        Also, there are no problems in the distribution of the app for mobile devices, as it uses the Play Store for Android and the App Store for iOS.
        
        Unfortunately, the data protection laws in force on the Chinese territory require that all personal information collected from customers must be saved only on internal state databases, also in China there is no Play Store to distribute the app on Android devices.
        
%---------------------------------------------------------------

        \subsection{Interviews}
        To overcome these obstacles it is necessary to review the entire system, identifying the correct infrastructure to ensure that it is CSL compliant.
                
        First, we need to clarify all the critical points of the project and analyze the borderline cases to ensure that we comply with the law.
        
        There were question and answer sessions with industry experts, below are the results that emerged regarding Salesforce and the mobile app.        

%----------------------------------------------

            \subsubsection{Salesforce}
            \begin{itemize}
                \item \textbf {Saving data outside China}: if a Chinese citizen goes to a retailer or attends an event that takes place outside the Chinese territory, their data can be saved on servers outside of China.
                
                \item \textbf{Login}: the access of an administrator to the platform in China is tied to the organization from which these administrator users come.
                
                The transmission of \textbf {Personal Identification Information (PII)} must be traceable through control registers, we need to know: who accessed the data, when, how and for what activity (reading, modification, deletion, etc.).
                
                \newpage

                \item \textbf {Integration}: data stored on Chinese territory, can be viewed from Europe in read-only mode.
                
                However, this is possible if the customer has consented to the storage of their data across the Chinese border.

                \item \textbf {Sensitive Data}: \textbf {basic PII} describe social or natural attributes, such as: date of birth, gender, nationality, occupation, position, postcode, name, address, job, etc.

                Instead the \textbf {sensitive PII} are those:
                \begin{itemize}
                    \item \textbf {About property}: credit card number, identification information, deposit information, etc.
                    
                    \item \textbf {Health}: food allergies, past medical history, diagnosis and treatment, etc.
                    
                    \item \textbf {Biometrics}: fingerprint, DNA, facial recognition, etc.
                    
                    \item \textbf {Privacy}: sexual orientation, marriage, religion, criminal record, etc.
                    
                    \item \textbf {On identity}: identification number, passport number, etc.

                    \item \textbf {Other information}: precise information about the location, call log, etc.
                \end{itemize}
                    
                All this data can be transmitted and stored cross-border provided that:                    \begin{itemize}
                        \item the customer gives \textbf {consent} to do it
                        \item there is an obvious \textbf {business need} for sending data
                        \item technical measures for the transmission and storage of PII have been implemented, these data must be \textbf {encrypted or tokenized}, in this way they are anonymized.
                    \end{itemize}
                
                Anonymized data can be stored outside the \textbf {PRC (People's Republic of China)} and should never be saved in clear text, data security must be guaranteed.
                
                \item \textbf {Vehicle management}: if a vehicle has a Chinese license plate but the customer is a non-Chinese citizen, his data can be accessed.

                \item \textbf {Mobile App Support}: For support requests that need to be handled by the head office, data can be accessed from Europe.
                
                Always keep track of physical transmission and storage of PII through audit logs.
                
                \item \textbf {Document Privacy}: If a Chinese customer has provided consent, the retailer can only be trusted to confirm that they have received their permission.
                
                It is not possible to verify the content of the privacy document that the customer has signed.
                
                \item \textbf {Digital Privacy}: The use of digital privacy (via an external platform for electronic signature) remains limited to territories outside of China.
                
                A dedicated and approved platform for China only would be needed.
                
                \item \textbf{Webform}: we want to block inquiries to Chinese resellers for all webforms, but we needs to be investigated on how to handle them in China.
            \end{itemize}
            
            \newpage

%----------------------------------------------

            \subsubsection{App mobile}
            \begin{itemize}
                \item \textbf {Invitation process}: currently takes place through the dealer or head office (HQ), for the future it is necessary to consider using \textbf {WeChat} instead of the invitation email as the latter are not widely used in China.
                
                The content of the invitation, if done via WeChat, is similar to the email, except for the addition of a link to redirect the user to the App store or Android Store, as Google is not supported in China. We need to study a method to create a direct link to download the app and allow its support.
                
                If it is not possible to manage data centrally, everything must be localized. In this case it is possible to resort to a customer's plant already located in China, the invitation part could be localized, this would simplify management.
                
                It is necessary to evaluate the management of marketing campaigns, since there is already a customer structure in China that deals with it, it could be used for delegation and training issues, only for invitations and not for support.
                
                \item \textbf {Design}: there is no design difference to make to the app, only slight differences in some aspects (e.g. login via social media with WeChat instead of Facebook)
                
                \item \textbf {Store overview}: for iOS there are no problems in duplicating the app on the Chinese App Store, for Android instead, since there is not a single store, it should be made available on each of them (from Huawei to Xiaomi ).
                
                \item \textbf {Support and handling of requests}: Currently, there is a user responsible for all invitations coming from the HQ.
                
                In case we proceed to duplicate the app for China, this person would still like to keep the processes centralized.
                
                To offer support in China, there is already an office in the area.         
                
                \item \textbf {Configurator for the car}: we have few information on this point, further information is needed with those directly involved to understand its correct functioning.
                
                \item \textbf {Appointments}: also in this case the information are few, we have to contact someone from the market. There may be some borderline cases that need to be handled.
                
                For example: the case of a Chinese customer who bought in Macau (one of the special administrative regions along with Hong Kong) and is connected to the HQ outside of China and therefore cannot contact the Chinese dealer to have the car overhauled or for problems with other related services (services related to cars purchased outside China do not work in China).
                
                \item \textbf {Maps}: we must pay attention to the maps, now they use \textbf {Here} and \textbf {Google} depending on the country of construction of the car.
                Here is not supported in China but Google does, only to view the map and not as a navigation system.
                
                If it is necessary to use the navigator, the user will be redirected to the provider from the phone (Waze, Maps, etc.).
                
                There are no problems with the reports because the data, anonymized, can be brought to Europe.
                
                \item \textbf{Club}: there are clubs in China but they are not currently managed by the HQ. The communication process will change as it is currently handled via email and will need to be replaced by WeChat.
                
                \item \textbf {Events and news}: contents are now managed at the HQ level. We would like to maintain centralized management by giving the Chinese market the ability to publish specific content for its territory
                
                From a technical point of view, it is necessary to understand how to make the targets created in HQ available and functional also for the contents published in China.
                
                \item \textbf {Notifications}: as regards the notifications, it will not be possible to see who they have been sent to and how many have been opened, from Europe it will only be possible to have the aggregate data for reporting purposes. Those who operate in the Chinese market will be able to see everything.
                
                From a technical point of view, it is necessary to understand how to make HQ targets available and also work for notifications of content published in China.
                
                \item \textbf {Connectivity}: monitoring systems are required, all control methods must be replicated.
                
                If we decide to keep a single worldwide app, all the logic must be replicated.
                
                If, on the other hand, we decide to use two apps, one for China and the other for the rest of the world, this would grant the right to consult so we can also read the data from HQ, obviously it would be an aggregate data.
                
                One point to watch out for is support, data consultation rights may be required for second level assistance.
                
                \item \textbf {Virtual Manual}: can work like now.
            \end{itemize}

%--------------------------------------------------------------------------

    \section{Assessment}
    Through a a \textbf {checkpoint}, made with the goal of summarizing the work carried out up to that moment, the objectives of the project and the information that emerged from the interviews previously analyzed were summarized and the critical issues encountered and the possible solutions identified were exposed.    
    
    Concluding, an overview of future technical applications took place, describing: how to achieve them, what benefits would they bring and what are the estimated times to implement them.
    
%--------------------------------------------------------------

        \subsection{Choice of the structure}
        Two possible scenarios emerged that differ in the use of the Org that will operate on Chinese territory.
        
%----------------------------------------------
        
            \subsubsection{One single Org}
            The first solution involves the use one single Org for both China and the rest of the world.
            
            The data collected in China will be stored both in a database located on Chinese territory and in a European database but in this case they must be anonymized.
            
            To process the data in the Chinese database they must be sent to the Salesforce cloud platform whose servers are located in Europe.
             
            In the next image, the line that separates the drawing divides what is already present in Europe from the structures that will be positioned on Chinese territory, so each element above the straight line does not currently exist and will have to be implemented.
             
            \noindent
            \centerline{\includegraphics[scale=0.5]{1-org}}
            
            \bigskip
            
            Salesforce has to interface with numerous platforms:
            \begin{itemize}
                \item \textbf{Auto Order Tool}: to insert new vehicle orders, this information is subsequently sent to Salesforce.
                \item \textbf{Aftersale Tool}: for post-sale operations.
                \item \textbf{Heroku}: is a gateway to communicate stored information to the mobile app used by end users, i.e. car owners.
                \item \textbf{Marketing Cloud}: Salesforce module for sending marketing information to customers via push notifications or email.
                \item \textbf{Webform}: recently introduced tool to communicate directly with the workers of the car company.
            \end{itemize}
                
            In this \textbf {first scenario}, the backend calls the Chinese gateway to access the data and authorized users, Chinese retailers will be able to see the data in clear text because the anonymized information is replaced with the actual data in real time. Instead, unauthorized users, outside of China, will only be able to see anonymized data.
            
            \noindent
            The advantages of this approach are:
            \begin{itemize}
                \item Simple anonymous reporting.
                \item Reduced waiting times.
                \item Only one system to maintain.
                \item One IT team.
            \end{itemize}
            
            Relying on an \textbf {external platform} to \textbf {anonymize} and \textbf {decode} the saved data would result in:

            \begin{itemize}
                \item \textbf {Data Protection}: Businesses can use data without worrying about putting customers' intellectual property at risk.
                    
                \item \textbf {No Boundaries}: The tool would protect sensitive data in the cloud allowing the data to be used across the enterprise safely.
                
                \item \textbf {Coverage of all data}: its application extends to all types of data: customer name, address, demographic information, e-mail, date of birth and account history details.
                
                \item \textbf {Anonymization / Encryption / Tokenization}: data can be shared with SaaS, such as Salesforce, protecting them through anonymization and ensuring that this procedure is not reversible.
            \end{itemize}

            \newpage

            \noindent
            Providing the following benefits to the project:
            \begin{itemize}
                \item \textbf {Compliance}: Keeps companies up to date with various data regulations (eg GDPR, CCPA, New York SHIELD Act, etc.).
                
                \item \textbf {Accessibility}: allows access to sensitive data while preserving privacy, protecting specific elements and allowing them to be viewed when needed.
                
                \item \textbf {Enhancement}: companies have the power to innovate their business by sharing data with a mature privacy strategy.
                
                \item \textbf {Speed}: relying on this tool, there are fewer parts to implement and therefore faster development times.
            \end{itemize}

            A \textbf {orchestrator} (ORC) and two \textbf {engine} (E1 and E2) are added to the architecture in order to irreversibly protect the data.

            The orchestrator's job is to ensure that sensitive data policies are applied consistently by providing:
            
            \begin{itemize}
                \item Control systems.
                \item Warning techniques in case of problems.
                \item Methods for administering its functions.
            \end{itemize}
            
            \newpage
            
            \noindent
            Engines can operate in 2 ways to protect and reveal data:                        
            
            \begin{itemize}
                \item Leaving the app the ability to make independent calls to the Engines via API when anonymization is required.
                This offers a wider range of customization for applications, as they choose which API to invoke, plus it is more performing.
                
                \bigskip
                
                \noindent
                \centerline{\includegraphics[scale=0.8]{Engine-callApi.JPG}}
                
                \item By intercepting the content of a communication between two apps that communicate with each other via REST / HTTPS, entering directly into the data flow.
                In this case, to understand if the data flow is linked to a Chinese customer, it is possible to insert prefixes and suffixes to the anonymized data, which also simplifies the de-anonymization phase. These prefixes and suffixes must be special characters that are never commonly used, but only Latin characters for Salesforce limits.
                
                \bigskip
                
                \noindent
                \centerline{\includegraphics[scale=0.8]{Engine-packetInterc.JPG}}            
            
            \end{itemize}
            
            \newpage
            
            With the introduction of these tools, to \textbf{create or update} a new customer from China: the user will enter the data on Salesforce and, before being saved on the European DB, the data is displayed to the engine for tokenization.
            
            Then, data return to Salesforce and stored in Europe anonymously. A parallel stream will save the clear data on the Chinese DB.
            
            During the design phase, the appropriate considerations on how to technically implement these flows will be carried out.
            
            \bigskip
            \bigskip
            \bigskip
            \bigskip
            
            \noindent
            \centerline{\includegraphics[scale=0.55]{1-org_Insert-update.jpg}}
            
            \newpage
            
            If an \textbf{authorized user} tries to access Chinese data, the data is de-tokenized by the engine which returns it as clear text.
            
            \bigskip
            \bigskip
            \bigskip
            \bigskip
            
            \noindent
            \centerline{\includegraphics[scale=0.55]{1-org_aut.jpg}}
            
            \newpage

            Finally, if an \textbf{unauthorized user} tries to read the Chinese data, this data will show up as tokenized and therefore unreadable.
            
            \bigskip
            \bigskip
            \bigskip
            \bigskip
            
            \noindent
            \centerline{\includegraphics[scale=0.55]{1-org_unaut.jpg}}
            
            \newpage      
            
%----------------------------------------------
        
            \subsubsection{Two different orgs}
            The second solution uses an Org dedicated exclusively to China, the data will be saved and processed locally, each functionality must be replicated.
            In this scenario, the Chinese data are not anonymized in a segregated area in China.
            
            \noindent
            The data are:
            \begin{itemize}
                \item \textbf {Anonymized} only from the Chinese CRM to the European network.
                \item \textbf{De-anonymized} only from the EU European network to CRM in China.
            \end{itemize}
            
            \bigskip
            \bigskip
            
            \noindent
            \centerline{\includegraphics[scale=0.6]{2-org.jpg}}
            
            \newpage

            \noindent
            Advantages:
            \begin{itemize}
                \item \textbf{Security}.
                \item More \textbf {space} for technical development.
            \end{itemize}
            
            \noindent
            Disadvantages:
            \begin{itemize}
                \item It requires a huge amount of work and therefore \textbf {high development times}.
                \item Feasible only if there is the availability of being able to \textbf {allocate servers} of Salesforce and Heroku in China.
                \item The \textbf {anonymization} of the data continues to be required for the aftersale tool as it cannot be duplicated.
            \end{itemize}            

            Then the use of an external platform is necessary to anonymize the data, making the architecture as follows. \\
            
            \noindent
            \centerline{\includegraphics[scale=0.6]{2-org-TO-BE.jpg}}
            
%-----------------------------------------------------------

        \subsection{Comparison in a nutshell}
        \bigskip        

\begin{center}
    \begin{tabular}{C{6cm}|C{3cm}|C{3cm}}
        \hline 
            & \textbf {Scenario 1 (Single Org)} & \textbf {Scenario 2 (Double Org)} \\
        \hline
            Use an external anonymization platform 
                & 
            \checkmark
                &
            \checkmark \\
        \hline
            Need to redefine the current architecture 
                & 
            Reduced
                &
            High \\
        \hline
            Ability to access Chinese data from the EU (if authorized) 
                & 
            \checkmark
                & 
            \checkmark \\
        \hline
            System to maintain 
                & 
            Single
                & 
            Double \\
        \hline
            Chinese data segregation 
                & 
            Medium
                & 
            High \\
        \hline
            Impact on the seller 
                & 
            Low
                & 
            Very high \\
        \hline
            Implementation time 
                & 
            About 6 months
                & 
            More than 12 months \\
        \hline   
            Cost of implementation 
                & 
            Medium
                & 
            Very high \\
        \hline
    \end{tabular}
\end{center}

        \bigskip
        
        Against this comparative table, the \textbf{first scenario} is the one recommended by the company for the customer, its lower cost and reduced development time make it the \textbf{winning solution}.
        \newpage

%-----------------------------------------------------------

        \subsection{Method of anonymization}
        There are two methods for anonymizing data:
        \begin{itemize}
            \item \textbf{cryptography}
            \item \textbf{tokenization}
        \end{itemize}
        
        Each of them has advantages and disadvantages, so a proper comparison is necessary before choosing which one to adopt.

        \bigskip
        
\begin{center}
    \begin{tabular}{C{1.5cm}|C{6cm}|C{6cm}}
        \hline 
            & \textbf{Cryptography} & \textbf{Tokenization}  \\
        \hline
            \textbf{Pros}
                & 
            It offers greater performance with a high volume of data and only one key is required to decrypt
                &
            The data format can be maintained without reducing security and the risk of data breach is reduced thanks to the presence of multiple secret keys and algorithms \\
        \hline
            \textbf{Cons}
                & 
            It does not preserve the format of the input data and exposes you to a greater risk of data breach as there is only one key \smallskip
                &
            Slight performance loss as database size increases \smallskip \\
        \hline
    \end{tabular}
\end{center}        

        \newpage
        Tokenization is therefore the most convenient choice, in the following example a direct application of it is presented in which different levels of permission are defined for access to data by different users.
        
        \bigskip

\begin{center}
    \begin{adjustwidth}{-3cm}{}
        \begin{tabular}{C{3cm}|C{3.5cm}|C{3.5cm}|C{3.5cm}|C{3.5cm}}
            \hline 
                 \textbf{Identifier} & \textbf{Visible data} & \textbf{Anonymized} & \textbf{Authorization 1 (total visible data)} & \textbf{Authorization 2 (partial visible data)}   \\
            \hline
                \textbf{Name} \smallskip
                    & 
                James Cameroon \smallskip
                    &
                hwqax lansdtyi \smallskip
                    & 
                James Cameroon \smallskip
                    &
                James Cameroon \smallskip\\    
            \hline
                \textbf{Address}
                    & 
                21 Bishops Drive, Hampton
                    &
                47 Srt2aw8 Co1te, W63tyui
                    & 
                21 Bishops Drive, Hampton
                    &
                “No Access” \\
            \hline
                \textbf{Date of birth} \smallskip
                    & 
                12/25/1966 \smallskip
                    &
                01/02/1973 \smallskip
                    & 
                12/25/1966 \smallskip
                    &
                01/02/1973 \smallskip \\                
            \hline
                \textbf{Email address}
                    & 
                j.camer@surf.org 
                    &
                e.nwueb@beus.aku 
                    & 
                j.camer@surf.org 
                    &
                e.nwueb@beus.aku \\                
            \hline
                \textbf{Telephone number}
                    & 
                760-278-3389
                    &
                998-389-2289
                    & 
                760-278-3389
                    &
                998-389-2289 \\                
            \hline                        
        \end{tabular}
    \end{adjustwidth}
\end{center}           

\newpage

%-----------------------------------------------------------

        \subsection{Software selection}
        For each implementation, there are multiple software that allow it to be implemented, the "Software selection" phase was created to analyze the various possibilities and choose the best one.
        
        Below I report all the tools taken into consideration in order to build the external data anonymization platform.
        
        \bigskip
        
%----------------------------------------------

            \subsubsection{Protegrity}
            \begin{wrapfigure}{l}{0.5\textwidth}
                \centering
                \includegraphics[width=0.5\textwidth]{Protegrity.png}
            \end{wrapfigure}
            
            Protegrity Data Protection Platform allows customers to replace fields containing information with artificial or pseudonymous identifiers to protect operational and transactional data.
            The tool supports tokenization and de-tokenization.
            
            \bigskip
            \bigskip
        
%----------------------------------------------

            \subsubsection{Datprof}
            \begin{wrapfigure}{r}{0.5\textwidth}
                \centering
                \includegraphics[width=0.5\textwidth]{Datprof.png}
            \end{wrapfigure}
            
            Datprof Privacy is a high performance data masking software that enables the centralized development, execution and maintenance of rules and policies for data protection.
            \newpage
            
%----------------------------------------------

            \subsubsection{MENTIS}
            \begin{wrapfigure}{l}{0.5\textwidth}
                \centering
                \includegraphics[width=0.5\textwidth]{MENTIS.png}
            \end{wrapfigure}
            
            The static data masking of MENTIS iScramble is designed to provide total protection to sensitive data, integrates well with an organization's existing IT framework without the need for further architectural changes.
            
%----------------------------------------------
            
            \subsubsection{Delphix}
            \begin{wrapfigure}{r}{0.45\textwidth}
                \centering
                \includegraphics[width=0.45\textwidth]{Delphix.png}
            \end{wrapfigure}
            
            Delphix Dynamic Data Platform represents an automated approach to securing non-production environments by replacing sensitive data.
            
%----------------------------------------------

            \subsubsection{Informatica}
            \begin{wrapfigure}{l}{0.5\textwidth}
                \centering
                \includegraphics[width=0.5\textwidth]{Informatica.png}
            \end{wrapfigure}
            
            Informatica Data Masking makes sensitive data anonymous providing protection from unauthorized access by users, from tests carried out on applications and much more.
            
%----------------------------------------------

            \subsubsection{Netskope}
            \begin{wrapfigure}{r}{0.45\textwidth}
                \centering
                \includegraphics[width=0.45\textwidth]{Netskope_logo.png}
            \end{wrapfigure}
            
            Netskope takes an approach focused on data security in the cloud, following the data wherever it goes. Protects data created and exposed in the cloud, unmanaged cloud apps, and personal devices.
            
%----------------------------------------------

        \subsection{Solution chosen}
        The most convenient solution is \textbf {Protegrity}, this tool allows companies to use data for: advanced analysis, machine learning and artificial intelligence, without worrying about exposing sensitive information about customers or employees.
        
        \begin{wrapfigure}{r}{0.4\textwidth}
            \centering
            \includegraphics[width=0.4\textwidth]{protegriry-circle.png}
        \end{wrapfigure}            
        
        Simultaneously with data protection, the platform is able to classify them in various categories decided by the user
    
        This tool uses many encryption, tokenization and anonymization technologies, continuing to refine them over time by listening to customer requests.
        
        Anonymization allows us to irreversibly protect our data.
        
        Protegrity ensures that data can be used exactly the way we want and protects them from those who shouldn't see it. \cite {protegrity}
        
%-----------------------------------------------------------

        \subsection{Confrontation with the customer}
        Currently, there is a continuous dialogue between the parent company of the client company and the managers in China, this comparison aims to validate the single org solution previously presented and clarify all the doubts and perplexities connected to it.
        
        If this solution is accepted, Protegrity will be presented to the client, that is the solution that emerged from the software selection phase.
        
        Also in this case, a continuous dialogue with the customer will be necessary to validate this solution and, if accepted, to complete the assessment phase.   

%-------------------------------------------------------------------------------------------------------

\chapter{Future developments}
At the end of the assessment phase, it will be necessary to establish in detail which data will be anonymized and protected at the \textbf{single field} level.

Furthermore, we will estimate the \textbf{impact} that the chosen implementation will have on the current system and how to react to any problems that arise.

There are still some points left open regarding the \textbf {app} for mobile devices, we need to clarify these to establish how the app will be managed and what changes it will need compared to the one currently in use outside the Chinese territory.

Finally, the \textbf {implementation development} of the project will begin, establishing:

\begin {itemize}
    \item the \textbf {Platform as a Service} to be used for China.
    \item the type of \textbf {database} that will be placed on Chinese territory, also defining the data encryption method to guarantee its security as requested by the customer.
\end {itemize}

\newpage

At the same time as the development, numerous tests will also be carried out on the platform to:

\begin {itemize}
    \item verify compliance with Chinese law.
    \item make sure that the code we write is free from errors.
    \item make sure that the system is performing.
\end {itemize}

%-------------------------------------------------------------------------------------------------------

\chapter{Impact of the pandemic on the project}
The pandemic we are experiencing has affected every company, so I have included this chapter to tell the effects that COVID-19 has had on the team in charge of this project and how they were able to react to this situation.

%--------------------------------------------------------------------------

    \section{The beginning}
    Fortunately, the Covid has not significantly extended the estimated time for the start of the project. Thanks to the fast adaptation towards smart working, both on the part of the development team and on the customer's side, there was no considerable delay.
    
%--------------------------------------------------------------------------

    \section{Smart-Working}
    Smart working has not led to any block during development, especially because there is no need to physically travel to China. Instead, if it had been necessary to move to the Chinese territory then there would certainly have been delays and smart working would not have been fully applicable.

%--------------------------------------------------------------------------

    \section{Tools \& working methods}
    Due to the nature of this work, the team was already well prepared to operate remotely. Each member of the group already had computers and phones provided by the company to be able to work directly from home. Other small interventions, such as the increase of GB and the sending of devices to new hires by courier, have allowed continuity on the projects.
    
    In a short time, the team took full competence in the home meetings, planned in dedicated slots during the week and with a correct duration to be able to discuss the most important issues and work in a more structured way.
    
    The group chats were fundamental for quick interactions and, during the calls, the cameras kept open made it possible not to lose human contact, other tools such as MURAL (it is software for visual collaboration) favored planning, in place of the whiteboards for the workshops.
    
    The most important element that acts as a keystone was the great adaptability of the people.
    
    Furthermore, the company has never stopped offering meetings to all its employees to help improve the work methodology to be applied from home, to support the use of the various tools available and also to establish well-being sessions. which include: music, yoga and chat.

%--------------------------------------------------------------------------

    \section{Development times}
    The planning of the solutions has suffered delays, even if not particularly significant. In particular, in the first moments there was an expansion of the analysis and design activities, due to the impossibility of addressing the more complex issues in face-to-face meetings.
    
    Within a few weeks or months, a new balance was found which restored the correct rhythm of work.
    
%--------------------------------------------------------------------------

    \section{Advantages}
    Unexpectedly, smart working has brought advantages, first of all, there is the awareness of being able to react to even high-profile unforeseen events, like a global pandemic.
    
    This reaction has been both at the operational level (smart working) and business (increase in e-commerce projects or response plans for companies impacted by the crisis covid).
    
    It also brought the awareness of being able to change approach, tools and working methods practically instantly.
    
    In addition, even if for many it was a period of sacrifice, as the conditions at home were not easy, many other people, especially the younger ones, found an opportunity to reunite with loved ones outside the region.
    
    In this delicate moment also from the human point of view it is certainly relevant.

%--------------------------------------------------------------------------

    \section{Predictions for the future}
    Unfortunately, for the moment there is no certainty on this point, the return to the offices for 5 days a week is still a very distant event, as is the possibility of meeting customers in person.
    
    When the situation makes it possible, we will start seeing each other again in person and organizing events, from this situation it emerged that human contact has an essential importance, not so much on the delivery of projects but on the well-being of the people themselves and therefore on the company.

%-------------------------------------------------------------------------------------------------------

\chapter{Acknowledgments}
The last year has brought many changes, our habits, passions, jobs and social relationships have undergone profound changes and we have not always been able to adapt to this rapid upheaval.

Before concluding, I would like to thank everyone in the company who helped me realize this thesis and graduate

And of course, I can't forget to thank my friends too, especially Edo, Alex and Elia, who help me relieve stress and forget about the period we are living.

%-------------------------------------------------------------------------------------------------------

\addcontentsline{toc}{chapter}{Bibliography}
\printbibliography

\end{document}
